/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package casovac;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author nav79
 */
public class CasovacBean implements Casovac {
    private List<CasovacListener> listeners = new ArrayList<>();
    private int time=5;


    @Override
    public void addCasovacListener(CasovacListener l) {
        listeners.add(l);
    }

    @Override
    public void removeCasovacListener(CasovacListener l) {
        listeners.remove(l);
    }

    @Override
    public void setTime(int interval) {
        time = interval;
    }

    @Override
    public void run() {
        new Thread(new Runnable() {

            @Override
            public void run() {
                try {
                    Thread.sleep(time*1000);
                } catch(InterruptedException e) {
                }
                fireTimesUp();
            }
        }).start();
    }

    private void fireTimesUp() {
        CasovacEvent event =  new CasovacEvent(this);
        for (CasovacListener listener: listeners) {
            listener.timesUp(event);
        }
    }
}
